<template>
  <!-- On list item click, open select box  -->
  <v-list-item
    dense
    class="block-height"
    @click="open"
  >
    <v-list-item-icon>
      <v-icon>mdi-translate</v-icon>
    </v-list-item-icon>
    <v-select
      ref="localeSelect"
      :items="languages"
      dense single-line
      :menu-props="{ top: true }"
      :value="$root.$i18n.locale"
      @change="setLocale"
    >
      <template #item="{ item, on, attrs }">
        <v-list-item v-bind="attrs" v-on="on">
          <v-list-item-title v-text="item.text" />
        </v-list-item>
      </template>
    </v-select>
  </v-list-item>
</template>
<script lang="ts">
import { Vue, Component, Ref } from 'vue-property-decorator';

import { getUserLocales } from 'get-user-locale';

const KEY = 'dezrann-locale';

export enum AvailableLocale {
  'de-DE' = 'de-DE',
  'el-GR' = 'el-GR',
  'en-US' = 'en-US',
  'fr-FR' = 'fr-FR',
  'hr-HR' = 'hr-HR',
  'it-IT' = 'it-IT',
  'sl-SL' = 'sl-SL',
}

export function getPreferredLocale(): AvailableLocale {
  // Get the browser preferred locales
  const browserLocales = getUserLocales();
  // Get the user locale setting if available
  const userPrefLocale = localStorage.getItem(KEY);

  // Setup a list of locale by priority
  const locales = [
    ...(userPrefLocale ? [userPrefLocale] : []),
    ...browserLocales,
  ];

  // Return the first locale that is available (that belongs to the AvailableLocale object)
  return locales.find(
    (locale) => Object.prototype.hasOwnProperty.call(AvailableLocale, locale),
  ) as AvailableLocale
    || AvailableLocale['en-US'];
}

export function setPreferredLocale(locale: AvailableLocale): void {
  localStorage.setItem(KEY, locale);
}

interface VuetifySelect {
  isMenuActive: boolean;
}

@Component
export default class LocaleSwitcher extends Vue {
  languages = [
    { value: 'de-DE', text: 'Deutsch' },
    { value: 'el-GR', text: 'Ελληνικά' },
    { value: 'en-US', text: 'English' },
    { value: 'fr-FR', text: 'Français' },
    { value: 'hr-HR', text: 'Hrvatski' },
    { value: 'it-IT', text: 'Italiano' },
    { value: 'sl-SL', text: 'Slovenščina' },
  ];

  mounted() {
    this.setLocale(getPreferredLocale());
  }

  setLocale(locale: AvailableLocale) {
    this.$root.$i18n.locale = locale;
    this.$vuetify.lang.current = locale.split('-')?.[0] || 'en';
    setPreferredLocale(locale);
  }

  @Ref()
  localeSelect!: VuetifySelect;

  open() {
    this.localeSelect.isMenuActive = true;
  }
}
</script>
<style scoped lang="scss">
// Fixes an issue where the select item changes size when the sidebar unfolds
.block-height {
  height: 44px !important;
}
</style>
